<template>
	<div class="bg-white w-full md:w-690 lg:w-722 mb-2">
		<div class="px-4 pt-6 md:px-6 md:pt-6 lg:px-14 lg:pt-14">
			<h2 class="font-secondary-font-regular text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10">
				{{ dataObj.action === 'shipping' ? 'Select address' : 'Select payment' }}
			</h2>
			<p
				class="font-primary-font-light text-lg lg:text-xl leading-5 md:leading-6 text-black md:text-gray-40 lg:text-black mt-4 md:mt-2 lg:mt-8"
			>
				{{
					dataObj.selectedSubscription &&
					dataObj.selectedSubscription.lineItemList[0] &&
					dataObj.selectedSubscription.lineItemList[0].name
				}}
			</p>
		</div>
		<div class="px-0 md:px-6 lg:px-14">
			<MkNotificationError
				v-if="dataObj.infoObj && dataObj.infoObj['msg']"
				class="mt-6 lg:mt-12 rounded-none md:rounded-md lg:rounded"
				:error-obj="dataObj.infoObj"
			/>
		</div>
		<div class="px-4 pb-8 md:px-6 md:pb-10 lg:px-14 lg:pb-14">
			<div
				v-if="dataObj.action !== 'update_payment'"
				class="flex items-center cursor-pointer"
				@click="showCard()"
				@keypress.enter="showCard()"
			>
				<MkAddNewAddressTitle
					ref="add_button"
					tabindex="0"
					class="mt-8 lg:mt-12 focus:outline-none focus:ring-1 focus:ring-black"
					:show-add="showAdd"
					:title="dataObj.action === 'shipping' ? 'address' : 'card'"
					@add-address="addAddress"
				/>
			</div>
			<MkCheck
				v-else
				:checked="showAdd"
				radio-title="Edit card number"
				class="mr-3 lg:mt-12 md:mt-8 mt-8 mb-2"
				@change="showAdd = !showAdd"
			/>
			<ValidationObserver ref="card_validation_observer">
				<div v-if="['update_payment', 'payment'].indexOf(dataObj.action) > -1">
					<div v-if="showAdd" class="mt-8">
						<MkAddNewCreditcard />
					</div>
					<div v-if="dataObj.action === 'update_payment' && !showAdd && dataObj.cardDetails">
						<p class="mt-10 lg:mt-12 font-primary-font-bold text-base leading-6">
							{{ `${dataObj.cardDetails.brand} ${dataObj.cardDetails.last4}` }}
						</p>
						<p class="mt-2 font-primary-font-light text-base leading-6">
							{{ `exp.${dataObj.cardDetails.expMonth}/${dataObj.cardDetails.expYear.slice(2)}` }}
						</p>
					</div>
					<div v-if="dataObj.action === 'update_payment' || showAdd">
						<p class="mt-10 lg:mt-12 font-primary-font-bold text-base leading-6"> Billing address </p>
						<div class="mt-4 md:mt-0 lg:mt-2">
							<MkAddressForm id="affirm_address_form" v-model="paymentInfo" />
						</div>
						<div class="flex flex-col justify-center items-center mb-10">
							<MkPrimaryButton
								:loading="paymentLoading"
								class="font-primary-font-regular leading-6 mt-4 lg:mt-6 w-auto text-xl"
								button-title="Update Card"
								font-size="text-xl"
								@click="updateCard()"
							/>
						</div>
					</div>
				</div>
			</ValidationObserver>
			<MKSpinnerAnimation v-if="ACCOUNT_RESPONSE_WAIT" size-class="w-10 h-10 md:w-460 lg:w-610" />
			<MkCreditCard
				v-else-if="dataObj.action === 'payment' && CUSTOMER_CREDIT_CARD_DETAILS.length > 0"
				:credit-cards="CUSTOMER_CREDIT_CARD_DETAILS"
				@selected-card="
					($value) => {
						paymentInfo = $value;
					}
				"
			/>
			<ValidationObserver ref="shipping_validation_observer">
				<MkAddressForm v-if="dataObj.action === 'shipping' && showAdd" v-model="shippingInfo" />
				<div v-if="dataObj.action === 'shipping' && showAdd" class="flex flex-col justify-center items-center">
					<MkPrimaryButton
						:loading="loading"
						class="font-primary-font-regular leading-6 mt-8 lg:mt-10 mb-8"
						button-title="Save address"
						font-size="text-xl"
						@click="saveAddress()"
					/>
				</div>
				<MkAddressTile
					v-if="!ACCOUNT_RESPONSE_WAIT && dataObj.action === 'shipping'"
					:contents="CUSTOMER_SHIPPING_ADDRESS"
					:selected-address="selectedAddress"
					@selected="
						($event) => {
							selectedAddress = $event;
						}
					"
				/>
				<div
					v-if="
						(dataObj.action === 'payment' && CUSTOMER_CREDIT_CARD_DETAILS.length > 0) || dataObj.action === 'shipping'
					"
					class="flex flex-col justify-center items-center"
				>
					<MkPrimaryButton
						:disabled="
							ACCOUNT_RESPONSE_WAIT ||
							showAdd ||
							(dataObj.action === 'payment' && !(paymentInfo && paymentInfo['paymentId']))
						"
						class="font-primary-font-regular leading-6 mt-8 lg:mt-10"
						:loading="loading"
						button-title="Save"
						font-size="text-xl"
						@click="saveDetails(dataObj.action)"
					/>
				</div>
			</ValidationObserver>
			<div class="flex flex-col justify-center items-center">
				<p
					tabindex="0"
					role="button"
					class="cursor-pointer font-primary-font-bold text-base leading-6 mt-8 md:mt-6 mk-link focus:outline-none focus:ring-1 focus:ring-black"
					@keydown.enter="$emit('emitted-event', 'cancel')"
					@click="$emit('emitted-event', 'cancel')"
				>
					Cancel
				</p>
			</div>
		</div>
	</div>
</template>

<script>
import { ValidationObserver } from 'vee-validate';
import { mapState } from 'vuex';
import MkNotificationError from '~/components/D2C/atoms/MkNotificationError.vue';
import MkAddNewCreditcard from '~/components/D2C/atoms/MkAddNewCreditcard.vue';
import MkAddressForm from '~/components/D2C/molecules/MkAddressForm.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkCreditCard from '~/components/D2C/atoms/MkCreditCard.vue';
import MkAddNewAddressTitle from '~/components/D2C/atoms/MkAddNewAddressTitle.vue';
import MkAddressTile from '~/components/D2C/atoms/MkAddressTile.vue';
import MKSpinnerAnimation from '~/components/D2C/atoms/MKSpinnerAnimation.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';

export default {
	name: 'MkRefillsPay',
	components: {
		MkNotificationError,
		MkAddNewCreditcard,
		MkAddressForm,
		MkPrimaryButton,
		ValidationObserver,
		MkCreditCard,
		MkAddNewAddressTitle,
		MkAddressTile,
		MKSpinnerAnimation,
		MkCheck,
	},
	props: {
		dataObj: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			loading: false,
			showAdd: false,
			shippingInfo: {},
			selectedAddress: {},
			paymentInfo: {},
			creditCardDetails: {},
			saveData: false,
			paymentLoading: false,
		};
	},
	computed: {
		...mapState('USER_STORE', [
			'CREDIT_CARD_DETAILS',
			'ADDRESS',
			'AUTHENTICATED',
			'ACCOUNT_RESPONSE_WAIT',
			'SHIPPING_ADDRESSES',
			'CUSTOMERID',
			'CUSTOMER_SHIPPING_ADDRESS',
			'CUSTOMER_CREDIT_CARD_DETAILS',
			'VALID_ADDRESS',
		]),
	},
	mounted() {
		this.selectedAddress = this.dataObj.selectedAddress;
		this.$root.$utility.fieldFocus(this, 'add_button');
	},
	methods: {
		addAddress() {},
		showCard() {
			this.showAdd = !this.showAdd;
			if (this.showAdd) {
				this.selectedAddress = {};
			}
		},
		saveDetails(action) {
			this.saveData = true;
			if (action === 'shipping') {
				this.saveAddress();
			} else {
				this.savePayment();
			}
		},
		async saveAddress() {
			if (this.selectedAddress && this.selectedAddress.id) {
				// this.selectedAddress.id = this.selectedAddress.shippingAddressId
				this.updateSubscription('UPDATE_SHIPPING_ADDRESS');
			} else {
				try {
					const isValidForm = await this.$refs.shipping_validation_observer.validate();
					if (isValidForm && this.VALID_ADDRESS) {
						this.shippingInfo.streetName = this.shippingInfo.streetAddress1;
						this.shippingInfo.streetNumber = this.shippingInfo.streetAddress2 ? this.shippingInfo.streetAddress2 : '';
						this.shippingInfo.phone = this.shippingInfo.phoneNumber;
						this.shippingInfo.company = this.shippingInfo.companyName;
						this.shippingInfo.region = this.shippingInfo.state;
						this.loading = true;
						const $data = {
							action: 'ADD_SHIPPING_ADDRESS',
							shippingAddress: this.shippingInfo,
							isDefaultAddress: false,
						};
						await this.$store.dispatch('USER_STORE/UPDATE_CUSTOMER_BY_ID', $data);
						await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
					}
				} catch (error) {}
			}
		},
		savePayment() {
			const $data = {};
			$data.billingAddress = this.paymentInfo.defaultBillingAddress;
			$data.paymentId = this.paymentInfo.paymentId;
			$data.defaultPayment = this.paymentInfo.defaultStatus;
			$data.paymentToken = this.paymentInfo.paymentToken;
			this.subscriptionCard({
				type: 'edit',
				data: $data,
			});
		},
		async updateCard() {
			const isValidForm = await this.$refs.card_validation_observer.validate();
			if (!isValidForm && this.VALID_ADDRESS) {
				return;
			}
			this.paymentLoading = true;
			const payload = {};
			payload.action = 'ADD_PAYMENT';
			payload.billingAddress = this.paymentInfo;
			payload.billingAddress.streetName = this.paymentInfo.streetAddress1;
			payload.billingAddress.streetNumber = this.paymentInfo.streetAddress2 ? this.paymentInfo.streetAddress2 : '';
			payload.billingAddress.phone = this.paymentInfo.phoneNumber;
			payload.billingAddress.isBusiness = false;
			payload.billingAddress.company = '';
			payload.billingAddress.region = this.paymentInfo.state;
			payload.isDefaultPayment = false;
			const res = await this.$store.dispatch('USER_STORE/UPDATE_CUSTOMER_BY_ID', payload);
			this.showAdd = false;
			if (res === 'Success') {
				await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
				this.paymentLoading = false;
			} else {
				this.paymentLoading = false;
			}
		},
		async subscriptionCard(value) {
			if (value.type === 'edit') {
				const data = {
					d2CPaymentRequestBean: {},
				};
				data.d2CPaymentRequestBean = {
					billingAddress: value.data.billingAddress,
					isDefaultPayment: value.data.defaultPayment,
					isDefaultAddress: false,
					paymentId: value.data.paymentId,
					paymentToken: value.data.paymentToken,
					paymentType: 'CREDITCARD',
				};
				data.action = 'UPDATE_PAYMENT_OPTION';
				data.channel = 'D2C';
				this.creditCardDetails = data;
			} else {
				this.creditCardDetails = value.data;
			}
			await this.updateSubscription('UPDATE_PAYMENT_OPTION');
			this.showAdd = false;
			// await this.$store.dispatch('USER_STORE/FETCH_ACCOUNT');
			await this.$store.dispatch('USER_STORE/FETCH_CUSTOMER');
			await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', {});
		},
		async updateSubscription($action) {
			this.loading = true;
			const $data = {
				container: this.dataObj.selectedSubscription.container,
				key: this.dataObj.selectedSubscription.key,
				data: {
					action: $action,
					updateCartRequestBean: {
						// productId: this.dataObj.selectedSubscription.lineItemList[0].productId,
						// lineItemId: this.dataObj.selectedSubscription.lineItemList[0].lineItemId,
						// variantId: this.dataObj.selectedSubscription.lineItemList[0].variantId
					},
				},
			};
			try {
				switch ($action) {
					case 'UPDATE_QUANTITY':
						$data.data.updateCartRequestBean.quantity = this.subscriptionQty;
						$data.data.updateCartRequestBean.action = 'CHANGE_LINE_ITEM_QTY';
						break;
					case 'UPDATE_SHIPPING_ADDRESS':
						// this.selectedAddress.streetName = this.selectedAddress.streetAddress1
						// this.selectedAddress.phone = this.selectedAddress.phoneNumber
						// this.selectedAddress.company = this.selectedAddress.companyName
						$data.data.updateCartRequestBean.shippingAddress = this.selectedAddress;
						$data.data.updateCartRequestBean.action = 'SET_SHIPPING_ADDRESS';
						$data.data.shippingAddressId = this.selectedAddress.id;
						$data.data.shippingCarrierOptionsBean = {
							shippingAddress: this.selectedAddress,
							primaryShipping: this.selectedAddress.isDefault,
						};
						break;
					case 'UPDATE_RENEWAL_DATE':
						$data.data.renewalDate = this.$options.filters.formatDateAurora(this.selectedDay, 'YYYY-MM-DD');
						delete $data.data.updateCartRequestBean;
						break;
					case 'TURN_OFF':
						$data.data.surveyQuestionId = this.turnOffRefillSelected;
						delete $data.data.updateCartRequestBean;
						break;
					case 'UPDATE_PAYMENT_OPTION':
						$data.data = this.creditCardDetails;
						break;
				}
				await this.$store.dispatch('USER_STORE/UPDATE_SUBSCRIPTION_QUANTITY', $data);
				await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', {});
				this.loading = false;

				if (this.saveData) {
					this.saveData = false;
					this.$emit('emitted-event', 'saved');
				}
			} catch (exp) {
				await this.$store.dispatch('USER_STORE/GET_SUBSCRIPTIONS', {});
				this.loading = false;
				this.$emit('emitted-event', 'saved');
			}
		},
	},
};
</script>

<style lang="postcss">
.cc-input {
	width: 100%;
}
</style>
